"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Joi = require("joi");
class ActionProcessor {
    constructor(options, context, snapshot, parameters) {
        this.options = options;
        this.context = context;
        this.snapshot = snapshot;
        this.parameters = parameters;
    }
    /**
     * Validate options before processing.
     * Should throw exception on error.
     */
    validate() {
        return __awaiter(this, void 0, void 0, function* () {
            const schema = this.getValidationSchema();
            if (schema) {
                const result = Joi.validate(this.options, schema);
                if (result.error) {
                    throw new Error(result.error.details.map(d => d.message).join('\n'));
                }
            }
        });
    }
    /**
     * Get Joi schema to validate options with
     * Return null if no validation should be applied, though it is not recommended.
     */
    getValidationSchema() {
        return null;
    }
    /**
     * Check if action should be actually executed
     */
    isShouldExecute() {
        return __awaiter(this, void 0, void 0, function* () {
            return true;
        });
    }
}
exports.ActionProcessor = ActionProcessor;
//# sourceMappingURL=ActionProcessor.js.map