"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const models_1 = require("../../models");
const Joi = require("joi");
class BaseMarkEntityAsActionProcessor extends models_1.ActionProcessor {
    /**
     * @inheritdoc
     */
    getValidationSchema() {
        return BaseMarkEntityAsActionProcessor.validationSchema;
    }
}
exports.BaseMarkEntityAsActionProcessor = BaseMarkEntityAsActionProcessor;
BaseMarkEntityAsActionProcessor.validationSchema = Joi.array()
    .items(Joi.object({
    type: Joi.string()
        .min(1)
        .required(),
    id: Joi.alternatives(Joi.string()
        .min(1)
        .required(), Joi.number().required()).required(),
    payload: Joi.any(),
}))
    .min(1)
    .required()
    .options({ abortEarly: true });
//# sourceMappingURL=BaseMarkEntityAsActionProcessor.js.map