import * as Joi from 'joi';
import { ActionProcessor } from '../../models';
export declare abstract class BaseValuesAssignmentActionProcessor extends ActionProcessor {
    private static validationSchema;
    /**
     * @inheritdoc
     */
    getValidationSchema(): Joi.SchemaLike | null;
    /**
     * Get context field name to assign values
     */
    abstract getAssignmentKey(): 'ctx' | 'secrets';
    /**
     * Get value assignment target based on assignment key
     * @param context
     * @param parameters
     */
    private getAssignmentTarget;
    /**
     * @inheritdoc
     */
    validate(): Promise<void>;
    /**
     * @inheritdoc
     */
    execute(): Promise<void>;
}
