"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const BaseValuesAssignmentActionProcessor_1 = require("./BaseValuesAssignmentActionProcessor");
const models_1 = require("../../models");
class ContextValuesAssignmentActionProcessor extends BaseValuesAssignmentActionProcessor_1.BaseValuesAssignmentActionProcessor {
    /**
     * @inheritdoc
     */
    getAssignmentKey() {
        return 'ctx';
    }
    /**
     * @inheritdoc
     */
    execute() {
        const _super = Object.create(null, {
            execute: { get: () => super.execute }
        });
        return __awaiter(this, void 0, void 0, function* () {
            yield _super.execute.call(this);
            this.snapshot.setContext(this.context);
        });
    }
}
exports.ContextValuesAssignmentActionProcessor = ContextValuesAssignmentActionProcessor;
class ContextValuesAssignmentActionHandler extends models_1.ActionHandler {
    /**
     * @inheritdoc
     */
    getMetadata() {
        return ContextValuesAssignmentActionHandler.metadata;
    }
    /**
     * @inheritdoc
     */
    getProcessor(options, context, snapshot, parameters) {
        return new ContextValuesAssignmentActionProcessor(options, context, snapshot, parameters);
    }
}
exports.ContextValuesAssignmentActionHandler = ContextValuesAssignmentActionHandler;
ContextValuesAssignmentActionHandler.metadata = {
    id: 'com.fireblink.fbl.context.ctx',
    aliases: ['fbl.context.ctx', 'context.ctx', 'ctx'],
};
//# sourceMappingURL=ContextValuesAssignmentActionHandler.js.map