"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const models_1 = require("../../models");
const BaseMarkEntityAsActionProcessor_1 = require("./BaseMarkEntityAsActionProcessor");
class MarkEntitiesAsUnRegisteredActionProcessor extends BaseMarkEntityAsActionProcessor_1.BaseMarkEntityAsActionProcessor {
    /**
     * @inheritdoc
     */
    execute() {
        return __awaiter(this, void 0, void 0, function* () {
            this.context.entities.unregistered.push(...this.options);
            this.snapshot.setContext(this.context);
        });
    }
}
exports.MarkEntitiesAsUnRegisteredActionProcessor = MarkEntitiesAsUnRegisteredActionProcessor;
class MarkEntitiesAsUnRegisteredActionHandler extends models_1.ActionHandler {
    /**
     * @inheritdoc
     */
    getMetadata() {
        return MarkEntitiesAsUnRegisteredActionHandler.metadata;
    }
    /**
     * @inheritdoc
     */
    getProcessor(options, context, snapshot, parameters) {
        return new MarkEntitiesAsUnRegisteredActionProcessor(options, context, snapshot, parameters);
    }
}
exports.MarkEntitiesAsUnRegisteredActionHandler = MarkEntitiesAsUnRegisteredActionHandler;
MarkEntitiesAsUnRegisteredActionHandler.metadata = {
    id: 'com.fireblink.fbl.context.entities.unregistered',
    aliases: ['fbl.context.entities.unregistered', 'context.entities.unregistered', 'entities.unregistered'],
};
//# sourceMappingURL=MarkEntitiesAsUnRegisteredActionHandler.js.map