"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const models_1 = require("../../models");
const BaseMarkEntityAsActionProcessor_1 = require("./BaseMarkEntityAsActionProcessor");
class MarkEntitiesAsUpdatedActionProcessor extends BaseMarkEntityAsActionProcessor_1.BaseMarkEntityAsActionProcessor {
    /**
     * @inheritdoc
     */
    execute() {
        return __awaiter(this, void 0, void 0, function* () {
            this.context.entities.updated.push(...this.options);
            this.context.entities.registered.push(...this.options);
            this.snapshot.setContext(this.context);
        });
    }
}
exports.MarkEntitiesAsUpdatedActionProcessor = MarkEntitiesAsUpdatedActionProcessor;
class MarkEntitiesAsUpdatedActionHandler extends models_1.ActionHandler {
    /**
     * @inheritdoc
     */
    getMetadata() {
        return MarkEntitiesAsUpdatedActionHandler.metadata;
    }
    /**
     * @inheritdoc
     */
    getProcessor(options, context, snapshot, parameters) {
        return new MarkEntitiesAsUpdatedActionProcessor(options, context, snapshot, parameters);
    }
}
exports.MarkEntitiesAsUpdatedActionHandler = MarkEntitiesAsUpdatedActionHandler;
MarkEntitiesAsUpdatedActionHandler.metadata = {
    id: 'com.fireblink.fbl.context.entities.updated',
    aliases: ['fbl.context.entities.updated', 'context.entities.updated', 'entities.updated'],
};
//# sourceMappingURL=MarkEntitiesAsUpdatedActionHandler.js.map