"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const ContextValuesAssignmentActionHandler_1 = require("./ContextValuesAssignmentActionHandler");
const MarkEntitiesAsRegisteredActionHandler_1 = require("./MarkEntitiesAsRegisteredActionHandler");
const MarkEntitiesAsUnRegisteredActionHandler_1 = require("./MarkEntitiesAsUnRegisteredActionHandler");
const MarkEntitiesAsCreatedActionHandler_1 = require("./MarkEntitiesAsCreatedActionHandler");
const MarkEntitiesAsUpdatedActionHandler_1 = require("./MarkEntitiesAsUpdatedActionHandler");
const MarkEntitiesAsDeletedActionHandler_1 = require("./MarkEntitiesAsDeletedActionHandler");
const SecretValuesAssignmentActionHandler_1 = require("./SecretValuesAssignmentActionHandler");
const SummaryRecordActionHandler_1 = require("./SummaryRecordActionHandler");
const version = require(process.env.FBL_ENV === 'test' ? '../../../package.json' : '../../../../package.json')
    .version;
module.exports = {
    name: 'flb.core.context',
    version: version,
    actionHandlers: [
        new ContextValuesAssignmentActionHandler_1.ContextValuesAssignmentActionHandler(),
        new MarkEntitiesAsRegisteredActionHandler_1.MarkEntitiesAsRegisteredActionHandler(),
        new MarkEntitiesAsUnRegisteredActionHandler_1.MarkEntitiesAsUnRegisteredActionHandler(),
        new MarkEntitiesAsCreatedActionHandler_1.MarkEntitiesAsCreatedActionHandler(),
        new MarkEntitiesAsUpdatedActionHandler_1.MarkEntitiesAsUpdatedActionHandler(),
        new MarkEntitiesAsDeletedActionHandler_1.MarkEntitiesAsDeletedActionHandler(),
        new SecretValuesAssignmentActionHandler_1.SecretValuesAssignmentActionHandler(),
        new SummaryRecordActionHandler_1.SummaryRecordActionHandler(),
    ],
    requires: {
        fbl: version,
    },
};
//# sourceMappingURL=index.js.map