"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const models_1 = require("../../models");
const Joi = require("joi");
class EchoActionProcessor extends models_1.ActionProcessor {
    /**
     * @inheritdoc
     */
    getValidationSchema() {
        return EchoActionProcessor.validationSchema;
    }
    /**
     * @inheritdoc
     */
    execute() {
        return __awaiter(this, void 0, void 0, function* () {
            console.log(this.options);
        });
    }
}
exports.EchoActionProcessor = EchoActionProcessor;
EchoActionProcessor.validationSchema = Joi.any()
    .required()
    .options({ abortEarly: true });
class EchoActionHandler extends models_1.ActionHandler {
    /**
     * @inheritdoc
     */
    getMetadata() {
        return EchoActionHandler.metadata;
    }
    /**
     * @inheritdoc
     */
    getProcessor(options, context, snapshot, parameters) {
        return new EchoActionProcessor(options, context, snapshot, parameters);
    }
}
exports.EchoActionHandler = EchoActionHandler;
EchoActionHandler.metadata = {
    id: 'com.fireblink.fbl.flow.echo',
    aliases: ['fbl.flow.echo', 'flow.echo', 'echo'],
};
//# sourceMappingURL=EchoActionHandler.js.map