"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const models_1 = require("../../models");
const Joi = require("joi");
class ErrorActionProcessor extends models_1.ActionProcessor {
    /**
     * @inheritdoc
     */
    getValidationSchema() {
        return ErrorActionProcessor.validationSchema;
    }
    /**
     * @inheritdoc
     */
    execute() {
        return __awaiter(this, void 0, void 0, function* () {
            throw new Error(this.options);
        });
    }
}
exports.ErrorActionProcessor = ErrorActionProcessor;
ErrorActionProcessor.validationSchema = Joi.string()
    .min(1)
    .required()
    .options({ abortEarly: true });
class ErrorActionHandler extends models_1.ActionHandler {
    /**
     * @inheritdoc
     */
    getMetadata() {
        return ErrorActionHandler.metadata;
    }
    /**
     * @inheritdoc
     */
    getProcessor(options, context, snapshot, parameters) {
        return new ErrorActionProcessor(options, context, snapshot, parameters);
    }
}
exports.ErrorActionHandler = ErrorActionHandler;
ErrorActionHandler.metadata = {
    id: 'com.fireblink.fbl.flow.error',
    aliases: ['fbl.flow.error', 'flow.error', 'error'],
};
//# sourceMappingURL=ErrorActionHandler.js.map