"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const models_1 = require("../../models");
const Joi = require("joi");
class SleepFlowActionProcessor extends models_1.ActionProcessor {
    /**
     * @inheritdoc
     */
    getValidationSchema() {
        return SleepFlowActionProcessor.validationSchema;
    }
    /**
     * @inheritdoc
     */
    execute() {
        return __awaiter(this, void 0, void 0, function* () {
            yield new Promise(resolve => setTimeout(resolve, Number(this.options) * 1000));
        });
    }
}
exports.SleepFlowActionProcessor = SleepFlowActionProcessor;
SleepFlowActionProcessor.validationSchema = Joi.alternatives(Joi.number().min(0), Joi.string().regex(/^\d+(\.\d+)?$/)).required();
class SleepFlowActionHandler extends models_1.ActionHandler {
    /**
     * @inheritdoc
     */
    getMetadata() {
        return SleepFlowActionHandler.metadata;
    }
    /**
     * @inheritdoc
     */
    getProcessor(options, context, snapshot, parameters) {
        return new SleepFlowActionProcessor(options, context, snapshot, parameters);
    }
}
exports.SleepFlowActionHandler = SleepFlowActionHandler;
SleepFlowActionHandler.metadata = {
    id: 'com.fireblink.fbl.flow.sleep',
    aliases: ['fbl.flow.sleep', 'flow.sleep', 'sleep'],
};
//# sourceMappingURL=SleepFlowActionHandler.js.map