import * as Joi from 'joi';
import { ActionHandler, ActionSnapshot, ActionProcessor } from '../../models';
import { IActionHandlerMetadata, IContext, IDelegatedParameters } from '../../interfaces';
import { BaseFlowActionProcessor } from './BaseFlowActionProcessor';
export declare class WhileActionProcessor extends BaseFlowActionProcessor {
    private static validationSchema;
    /**
     * @inheritdoc
     */
    getValidationSchema(): Joi.SchemaLike | null;
    /**
     * @inheritdoc
     */
    isShouldExecuteWithParameters(parameters: IDelegatedParameters): Promise<boolean>;
    /**
     * @inheritdoc
     */
    isShouldExecute(): Promise<boolean>;
    /**
     * @inheritdoc
     */
    execute(): Promise<void>;
}
export declare class WhileActionHandler extends ActionHandler {
    private static metadata;
    /**
     * @inheritdoc
     */
    getMetadata(): IActionHandlerMetadata;
    /**
     * @inheritdoc
     */
    getProcessor(options: any, context: IContext, snapshot: ActionSnapshot, parameters: IDelegatedParameters): ActionProcessor;
}
