"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const AttachedFlowActionHandler_1 = require("./AttachedFlowActionHandler");
const EchoActionHandler_1 = require("./EchoActionHandler");
const ForEachFlowActionHandler_1 = require("./ForEachFlowActionHandler");
const ParallelFlowActionHandler_1 = require("./ParallelFlowActionHandler");
const SequenceFlowActionHandler_1 = require("./SequenceFlowActionHandler");
const SwitchFlowActionHandler_1 = require("./SwitchFlowActionHandler");
const RepeatFlowActionHandler_1 = require("./RepeatFlowActionHandler");
const TemplateFlowActionHandler_1 = require("./TemplateFlowActionHandler");
const TryCatchFinallyFlowActionHandler_1 = require("./TryCatchFinallyFlowActionHandler");
const VirtualFlowActionHandler_1 = require("./VirtualFlowActionHandler");
const ErrorActionHandler_1 = require("./ErrorActionHandler");
const WhileActionHandler_1 = require("./WhileActionHandler");
const SleepFlowActionHandler_1 = require("./SleepFlowActionHandler");
const VoidFlowActionHandler_1 = require("./VoidFlowActionHandler");
const RetryActionHandler_1 = require("./RetryActionHandler");
const version = require(process.env.FBL_ENV === 'test' ? '../../../package.json' : '../../../../package.json')
    .version;
module.exports = {
    name: 'fbl.core.flow',
    version: version,
    requires: {
        fbl: version,
    },
    actionHandlers: [
        new AttachedFlowActionHandler_1.AttachedFlowActionHandler(),
        new EchoActionHandler_1.EchoActionHandler(),
        new ErrorActionHandler_1.ErrorActionHandler(),
        new ForEachFlowActionHandler_1.ForEachFlowActionHandler(),
        new ParallelFlowActionHandler_1.ParallelFlowActionHandler(),
        new SequenceFlowActionHandler_1.SequenceFlowActionHandler(),
        new SleepFlowActionHandler_1.SleepFlowActionHandler(),
        new SwitchFlowActionHandler_1.SwitchFlowActionHandler(),
        new RepeatFlowActionHandler_1.RepeatFlowActionHandler(),
        new RetryActionHandler_1.RetryActionHandler(),
        new TemplateFlowActionHandler_1.TemplateFlowActionHandler(),
        new TryCatchFinallyFlowActionHandler_1.TryCatchFinallyFlowActionHandler(),
        new VirtualFlowActionHandler_1.VirtualFlowActionHandler(),
        new VoidFlowActionHandler_1.VoidFlowActionHandler(),
        new WhileActionHandler_1.WhileActionHandler(),
    ],
};
//# sourceMappingURL=index.js.map