"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const WriteToFileActionHandler_1 = require("./WriteToFileActionHandler");
const MakeDirActionHandler_1 = require("./MakeDirActionHandler");
const RemovePathActionHandler_1 = require("./RemovePathActionHandler");
const MovePathActionHandler_1 = require("./MovePathActionHandler");
const CopyPathActionHandler_1 = require("./CopyPathActionHandler");
const FindActionHandler_1 = require("./FindActionHandler");
const version = require(process.env.FBL_ENV === 'test' ? '../../../package.json' : '../../../../package.json')
    .version;
module.exports = {
    name: 'fbl.core.fs',
    version: version,
    actionHandlers: [
        new CopyPathActionHandler_1.CopyPathActionHandler(),
        new FindActionHandler_1.FindActionHandler(),
        new MakeDirActionHandler_1.MakeDirActionHandler(),
        new MovePathActionHandler_1.MovePathActionHandler(),
        new RemovePathActionHandler_1.RemovePathActionHandler(),
        new WriteToFileActionHandler_1.WriteToFileActionHandler(),
    ],
    requires: {
        fbl: version,
    },
};
//# sourceMappingURL=index.js.map