"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const STRING_TYPE = {
    type: 'string',
    pattern: '^\\$\\.(ctx|secrets|parameters)\\.[^.]+(\\.[^.]+)*$',
};
const FIELD_TYPE = {
    type: 'string',
    pattern: '^\\$\\.[^.]+(\\.[^.]+)*$',
};
class ContextTemplateUtility {
    /**
     * @inheritdoc
     */
    getUtilities(context, snapshot, parameters) {
        return {
            assignToSchema() {
                return {
                    anyOf: [
                        STRING_TYPE,
                        {
                            type: 'object',
                            properties: {
                                ctx: FIELD_TYPE,
                                secrets: FIELD_TYPE,
                                parameters: FIELD_TYPE,
                                override: {
                                    type: 'boolean',
                                },
                            },
                        },
                    ],
                };
            },
            assignTo(paths, value) {
                utils_1.ContextUtil.assignTo(context, parameters, snapshot, paths, value);
            },
            pushToSchema() {
                return {
                    anyOf: [
                        STRING_TYPE,
                        {
                            type: 'object',
                            properties: {
                                ctx: FIELD_TYPE,
                                secrets: FIELD_TYPE,
                                parameters: FIELD_TYPE,
                                override: {
                                    type: 'boolean',
                                },
                                children: {
                                    type: 'boolean',
                                },
                            },
                        },
                    ],
                };
            },
            pushTo(paths, value) {
                utils_1.ContextUtil.pushTo(context, parameters, snapshot, paths, value);
            },
        };
    }
}
exports.ContextTemplateUtility = ContextTemplateUtility;
//# sourceMappingURL=ContextTemplateUtility.js.map