"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../../utils");
const fs_1 = require("fs");
class FSTemplateUtility {
    /**
     * @inheritdoc
     */
    getUtilities(context, snapshot, parameters) {
        return {
            fs: {
                getAbsolutePath(path, workingDir = snapshot.wd) {
                    return utils_1.FSUtil.getAbsolutePath(path, workingDir);
                },
                read: {
                    text: (path, workingDir = snapshot.wd) => {
                        return fs_1.readFileSync(utils_1.FSUtil.getAbsolutePath(path, workingDir), 'utf8');
                    },
                    base64: (path, workingDir = snapshot.wd) => {
                        return fs_1.readFileSync(utils_1.FSUtil.getAbsolutePath(path, workingDir)).toString('base64');
                    }
                }
            }
        };
    }
}
exports.FSTemplateUtility = FSTemplateUtility;
//# sourceMappingURL=FSTemplateUtility.js.map