"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const object_collider_1 = require("object-collider");
const errors_1 = require("../../errors");
const utils_1 = require("../../utils");
const fs_1 = require("fs");
const typedi_1 = require("typedi");
const services_1 = require("../../services");
const path_1 = require("path");
class IncludeTemplateUtility {
    /**
     * @inheritdoc
     */
    getUtilities(context, snapshot, parameters, wd) {
        return {
            include: (path, extra) => __awaiter(this, void 0, void 0, function* () {
                if (object_collider_1.isMissing(path)) {
                    throw new errors_1.ActionError('Unable to execute "$.include(path)". Path value is missing.', errors_1.INVALID_CONFIGURATION);
                }
                const abolutePath = utils_1.FSUtil.getAbsolutePath(path, wd);
                let template = fs_1.readFileSync(abolutePath, 'utf8');
                const flowService = typedi_1.default.get(services_1.FlowService);
                const templateWD = path_1.dirname(abolutePath);
                template = yield flowService.resolveTemplate(context.ejsTemplateDelimiters.global, template, context, snapshot, parameters, extra, templateWD);
                return yield flowService.resolveTemplate(context.ejsTemplateDelimiters.local, template, context, snapshot, parameters, extra, templateWD);
            }),
        };
    }
}
exports.IncludeTemplateUtility = IncludeTemplateUtility;
//# sourceMappingURL=IncludeTemplateUtility.js.map