"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const uuidv4 = require('uuid/v4');
const uuidv5 = require('uuid/v5');
class UUIDTemplateUtility {
    /**
     * @inheritdoc
     */
    getUtilities(context, snapshot, parameters) {
        return {
            UUID: {
                v4: () => {
                    return uuidv4();
                },
                v5: {
                    DNS: (dns) => {
                        return uuidv5(dns, uuidv5.DNS);
                    },
                    URL: (url) => {
                        return uuidv5(url, uuidv5.URL);
                    },
                    custom: (name, uuid) => {
                        return uuidv5(name, uuid);
                    }
                }
            }
        };
    }
}
exports.UUIDTemplateUtility = UUIDTemplateUtility;
//# sourceMappingURL=UUIDTemplateUtility.js.map