"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Joi = require("joi");
const action_1 = require("./action");
const FBL_FLOW_SCHEMA = Joi.object({
    version: Joi.string().regex(/\d+(\.\d+)*/i),
    requires: Joi.object({
        fbl: Joi.string().min(1),
        plugins: Joi.object()
            .min(1)
            .pattern(/^.*$/, Joi.string().min(1)),
        applications: Joi.array()
            .items(Joi.string().min(1))
            .min(1),
    }),
    description: Joi.string(),
    pipeline: action_1.FBL_ACTION_SCHEMA,
}).options({ abortEarly: true });
exports.FBL_FLOW_SCHEMA = FBL_FLOW_SCHEMA;
//# sourceMappingURL=flow.js.map