"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const typedi_1 = require("typedi");
let TemplateUtilitiesRegistry = class TemplateUtilitiesRegistry {
    constructor() {
        this.cleanup();
    }
    /**
     * Register template utilities
     * @param {ITemplateUtility} templateUtility
     * @return {TemplateUtilitiesRegistry}
     */
    register(...templateUtility) {
        this.registry.push(...templateUtility);
        return this;
    }
    /**
     * Unregister template utilities
     * @param {ITemplateUtility} templateUtility
     * @return {TemplateUtilitiesRegistry}
     */
    unregister(...templateUtility) {
        for (const utility of templateUtility) {
            this.registry.splice(this.registry.indexOf(utility), 1);
        }
        return this;
    }
    /**
     * Generate utilities for tempalte
     * @param {IContext} context action context
     * @param {ActionSnapshot} snapshot action snapshot
     * @param {IDelegatedParameters} parameters action parameters
     * @param {string} wd working directory
     * @return {{[key: string]: any}}
     */
    generateUtilities(context, snapshot, parameters, wd) {
        const result = {};
        for (const utility of this.registry) {
            Object.assign(result, utility.getUtilities(context, snapshot, parameters, wd));
        }
        return result;
    }
    /**
     * Cleanup registry
     * @return {ActionHandlersRegistry}
     */
    cleanup() {
        this.registry = [];
        return this;
    }
};
TemplateUtilitiesRegistry = __decorate([
    typedi_1.Service(),
    __metadata("design:paramtypes", [])
], TemplateUtilitiesRegistry);
exports.TemplateUtilitiesRegistry = TemplateUtilitiesRegistry;
//# sourceMappingURL=TemplateUtilitiesRegistry.js.map